package cb99myu;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
 
public class FlightReservation extends HttpServlet {

    public void service(HttpServletRequest request, HttpServletResponse response)  throws ServletException, IOException {

	String rsv = "<reservation>\n";
	String command = ""; 
	// read the form data
	Enumeration values = request.getParameterNames();
	while(values.hasMoreElements()) {
	    String name = (String)values.nextElement();
	    String value = request.getParameterValues(name)[0];
	    if (name.equals("command")) {
		command=value;
	    } else {
		rsv +=  "     <"+name+">"+  value + "</"+name+">\n";
	    }
	}
	rsv += "</reservation>\n";
	//	   rsv.replace((char)13,'\');
	//    rsv.replace('\r\n','\n');
	response.setContentType("text/html");
	PrintWriter out = new PrintWriter ( response.getOutputStream( ), true );

	if (request.getParameter("name").equals(""))
	    printError(out);
	else if (command.startsWith("Reserve")) 
	    makeReservation(rsv,request,out);
	else if (command.startsWith("Show")) 
	    showReservation(rsv,request,out); 
	else if (command.startsWith("cancel")) { 
	    rsv=request.getParameter("rsv");
	    //      rsv.replace((char)13,(char)10);
	    //      rsv.replace((char)10,'|');

	    cancelReservation(rsv,request,out); 
	    showReservation(rsv,request,out); 
	}
	else { out.println("<body bgcolor=white>Undefined request could not be processed.<br>"+command+"</body>");}

    }

    public String getVal(String rsv,String tag) {
	int look=rsv.indexOf("<"+tag+">");
	if (look<0) return "";
	int s=rsv.indexOf(">",look);
	int e=rsv.indexOf("</",s);
	return rsv.substring(s+1,e);
    }

    public  void makeReservation(String rsv,HttpServletRequest request,PrintWriter out) throws  IOException {
	String filename = "/servers/cgi-http-class/htdoc/cps606fall99-cgi/cb99myu/flights.dbx";
	PrintWriter f =null;
	try {
	    f=new  PrintWriter( new FileWriter( filename,true ) );      // a character stream
	} catch (FileNotFoundException fnf) {
	    out.println( "DB File does not exists!" );
	}
	f.println(rsv);
	f.println(" * ");
	f.close();
	printHeader( out,getVal(rsv,"name"));
	out.println("Your Flight is reserved.");
	printReservation(rsv,out);
	printPersonalInfo(rsv,out);
	printFooter( out);
 
    }

    public  void cancelReservation(String rsv,HttpServletRequest request,PrintWriter out) throws  IOException {
	String filename = "/servers/cgi-http-class/htdoc/cps606fall99-cgi/cb99myu/flights.dbx";

	BufferedReader in =null;
	try {
	    in=new BufferedReader( new FileReader( filename ) );      // a character stream
	} catch (FileNotFoundException fnf) {
	    out.println( "DB File does not exists!" );
	}
	String line;
	String rsvs="";
	while ( ( line = in.readLine() ) != null ) 
	    {
		if ( line.indexOf("<reservation>")>=0 ) {
		    String record=line+"\n";
		    while ( line.indexOf("</reservation>")<0 )
			{line = in.readLine(); record+=line+"\n";}
		     if (compare(record,rsv) ){} //no need after correcting newlines
		    //  if (record.equals(rsv) ) {}
		    else rsvs+=record;
		}
	    }
	in.close();
	PrintWriter f =null;
	try {
	    f=new  PrintWriter( new FileWriter( filename ) );      // a character stream
	} catch (FileNotFoundException fnf) {}
	f.print(rsvs);
	f.println(" **");
	f.close();
    }


    public void showReservation(String rsv,HttpServletRequest request,PrintWriter out) throws  IOException  {
	String filename = "/servers/cgi-http-class/htdoc/cps606fall99-cgi/cb99myu/flights.dbx";
	BufferedReader in =null;
	try {
	    in=new BufferedReader( new FileReader( filename ) );      // a character stream
	} catch (FileNotFoundException fnf) {
	    out.println( "DB File does not exists!" );
	}
	String name=getVal(rsv,"name");
	printHeader( out,name);
	out.println("You have following reservation(s):");
	String line;
	String info=null;
	out.println("<table><tr><th align=left><ol>");
	while (  (line = in.readLine()) != null  ) 
	    {
		if ( line.indexOf("<reservation>")>=0 ) {
	  
		    String record=line+"\n";
		    while ( line.indexOf("</reservation>")<0 ) 
			{line = in.readLine(); record+=line+"\n";}
		    if (name.equals(getVal(record,"name"))) {
			out.println("<li>");
			printReservation(record,out);
			info=record;
			out.println("</li>");
		    }
		}
	    }
	out.println("</ol></th></tr></table>");
	if (info!=null)
	    printPersonalInfo(info,out);
	in.close();
	printFooter( out);
    }




    //////html
    void printReservation(String rsv,PrintWriter out) {
	out.println("");
	out.println("");
	out.println("<table >");
	out.println("");
	out.println("<tr><td></td><td></td><td  valign=center rowspan=6>");
	out.println("<font color='red' size='-1' face='Verdana, Arial, Helvetica, sans-serif'><b>");
	out.println("<form method='GET' action='http://class-server.npac.syr.edu:61699/cps606fall99-servlets/cb99myu/FlightReservation'>");
	out.println("");
	out.println("<input type=hidden name='rsv' value='"+rsv+"'>");
	out.println("<input type=hidden name='name' value='"+getVal(rsv,"name")+"'>");
	out.println("<input type=submit name='command' value='cancel'>");
	out.println("</form>");
	out.println("");
	out.println("</b></font></td></tr>");
									       
	out.println("<tr><td>From </td>");
	out.println("<td><font color=blue>"+getVal(rsv,"from")+"</font></td></tr>");
	out.println("<tr><td>To </td>");
	out.println("<td><font color=blue>"+getVal(rsv,"to")+"</font></td></tr>");
	out.println("<tr><td>Date, time </td>");
	out.println("<td><font color=blue>"+getVal(rsv,"fromMonth")+" "+getVal(rsv,"fromDay")+", "+getVal(rsv,"fromYear")+" @ "+getVal(rsv,"fromTime")+" "+getVal(rsv,"fromAMPM")+". </font></td></tr>");
	if ( getVal(rsv,"returning").equals("YES")) {
	    out.println("<tr><td colspan='2'><i>Returning back on </i><font color=green>"+getVal(rsv,"rtnMonth")+" "+getVal(rsv,"rtnDay")+", "+getVal(rsv,"rtnYear")+" @ "+getVal(rsv,"rtnTime")+" "+getVal(rsv,"rtnAMPM")+". </font></td></tr>");
	} else {out.println("<tr><td></td><td></td></tr>");}
	out.println("<tr><td><i><font color=gray>Notes</font></i> </td>");
	out.println("<td><i><font color=gray>"+getVal(rsv,"remarks")+"</font></i></td><tr>");
	       
	out.println("</table>");
	out.println("<p>");
	out.println("");
	out.println("");
	
    }
    void printPersonalInfo(String rsv,PrintWriter out) {
	out.println("<table width='70%' border=0 cellspacing=0 bgcolor='#ffcc66'>");
	out.println("<tr><td colspan=2><b><i><center>Personal Information</td>");
	out.println("<tr>");
	out.println("<tr><td>First Name </td>");
	out.println("<td><b>"+getVal(rsv,"fname")+"</td><tr>");
	out.println("<tr><td>Last Name </td>");
	out.println("<td><b>"+getVal(rsv,"name")+"</td><tr>");
	out.println("<tr><td>Address: </td>");
	out.println("<td><b>"+getVal(rsv,"address")+"<br>"+getVal(rsv,"City")+", "+getVal(rsv,"state")+" "+getVal(rsv,"zip-code")+"</td><tr>");
	out.println("</table>");
	
    }
    void printError(PrintWriter out) {
	printHeader( out,"");
	out.println("<font color=red>Please fill all the required fields.</font>");	 
	printFooter( out);
    }
    void printHeader(PrintWriter out,String name) {
	out.println("<html><body bgcolor='white'> <font color='#000000' size='-1' face='Verdana, Arial, Helvetica, sans-serif'><b>");
	out.println("<p><br><br><br>");	
	out.println("<center>");
	out.println("Thank you "+name+" for flying with <i><font color=cyan>M. Yuceer</font></i>'s planes.<br><br>");
	out.println("");
	out.println("");
    }
    void printFooter(PrintWriter out) {
	out.println("");
	out.println("<p><br><br><br><br>");
	out.println("<font color=blue><a href='JavaScript:history.back()'>B A C K</a></font>");
	out.println("<hr><small>&copy; Mehmet Yuceer Flight Reservations</small>");
	out.println("</center>");
	out.println("</b></font>");
	out.println("</body></html>");
    }
    //not called any more after one to one comparison bug fixed
    //however should be called in more complex record keeping situations
    boolean compare(String r1, String r2) {
	if (getVal(r1,"name").equals(getVal(r2,"name"))
	    && getVal(r1,"fname").equals(getVal(r2,"fname"))
	    && getVal(r1,"fromMonth").equals(getVal(r2,"fromMonth"))
	    && getVal(r1,"zip-code").equals(getVal(r2,"zip-code"))
	    && getVal(r1,"fromAMPM").equals(getVal(r2,"fromAMPM"))
	    && getVal(r1,"from").equals(getVal(r2,"from"))
	    && getVal(r1,"fromYear").equals(getVal(r2,"fromYear"))
	    && getVal(r1,"address").equals(getVal(r2,"address"))
	    && getVal(r1,"state").equals(getVal(r2,"state"))
	    && getVal(r1,"to").equals(getVal(r2,"to"))
	    && getVal(r1,"fromTime").equals(getVal(r2,"fromTime"))
	    && getVal(r1,"returning").equals(getVal(r2,"returning"))
	    && getVal(r1,"rtnAMPM").equals(getVal(r2,"rtnAMPM"))
	    && getVal(r1,"rtnYear").equals(getVal(r2,"rtnYear"))
	    && getVal(r1,"fromDay").equals(getVal(r2,"fromDay"))
	    && getVal(r1,"City").equals(getVal(r2,"City"))
	    && getVal(r1,"rtnTime").equals(getVal(r2,"rtnTime"))
	    && getVal(r1,"rtnDay").equals(getVal(r2,"rtnDay"))
	    && getVal(r1,"rtnMonth").equals(getVal(r2,"rtnMonth"))
	    && getVal(r1,"remarks").equals(getVal(r2,"remarks"))
	    )
	    return true;
	return false;

    }



}//class
