import java.lang.String;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.awt.Point;

public interface GameServerInterface extends Remote
{
    public void register(MuhabereInterface client) throws RemoteException;
    public void login(MuhabereInterface client, Object obj, String user) throws RemoteException;
    public void logout(String user) throws RemoteException;

    public void logoff(String user) throws RemoteException;
  //    public void broadcastMessage(String user,String ruser, long emsg[]) throws RemoteException;
  // public boolean askPartnership(MuhabereInterface client, String partner,String old) throws RemoteException;
 public MuhabereInterface  askPartnership(String player , String partner,String old) throws RemoteException;
    public void update(String user,Object obj) throws RemoteException;
    public void send(String partner,String otype,int x,int y,int z) throws RemoteException;
public MuhabereInterface es(String partner) throws RemoteException;
}
